/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "buehlmann.h"

dive_data my_dive;
GtkWidget *main_window;

/* stored globally for now...*/
GtkTreeModel *model;
GtkWidget *compart_treeview;
GtkListStore *store;
GtkTreeIter iter;

enum
  {
    COLUMN_NUMBER,
    COLUMN_T_12,
    COLUMN_PAMB_TOL,
    COLUMN_PIG_TOL,
    COLUMN_TE,
    NUM_COLUMNS
  };

static void
add_columns (GtkTreeView *compart_treeview)
{
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GtkTreeModel *model = gtk_tree_view_get_model (compart_treeview);

 /* add column for tissue number */
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("No.",
						     renderer,
						     "text",
						     COLUMN_NUMBER,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (compart_treeview), column);
  /* add column for tissue parameter t 1_2 */
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("t1/2",
						     renderer,
						     "text",
						     COLUMN_T_12,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (compart_treeview), column);
  /* add column for tissue parameter pamb_tol */
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("pamb\ntol",
						     renderer,
						     "text",
						     COLUMN_PAMB_TOL,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (compart_treeview), column);
  /* add column for tissue parameter pig_tol */
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("pig \ntol ",
						     renderer,
						     "text",
						     COLUMN_PIG_TOL,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (compart_treeview), column);
  /* add column for tissue parameter ndl */
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("te",
						     renderer,
						     "text",
						     COLUMN_TE,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (compart_treeview), column);

}


static GtkTreeModel *
create_model (void)
{
  gint i,y = 0;



  gchar t_12[10];
  gchar pamb_tol[10];
  gchar pig_tol[10];
  gchar te[10];

 /* create list store */
  store = gtk_list_store_new (NUM_COLUMNS,
			      G_TYPE_UINT,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING);


  /* add data to the list store */
  /* adding data to list */
  for (y=0; y<16; y++){
    
    sprintf(t_12,"%3.0f", my_dive.compart[y][C_T1_2]);
    sprintf(pamb_tol,"%2.2f", (my_dive.compart[y][C_PAMBTOL]>0 ? my_dive.compart[y][C_PAMBTOL] : 0.0));
    sprintf(pig_tol,"%2.2f", my_dive.compart[y][C_PIG_TOL]);
    sprintf(te,"%2.2f", my_dive.compart[y][C_TE]);

    gtk_list_store_append (store, &iter);
    gtk_list_store_set (store, &iter,
			COLUMN_NUMBER, y+1,
			COLUMN_T_12, t_12,
			COLUMN_PAMB_TOL, pamb_tol,
			COLUMN_PIG_TOL, pig_tol,
			COLUMN_TE, te,
			-1);
  }
  return GTK_TREE_MODEL (store);
}

int
main (int argc, char *argv[])
{
  //  GtkWidget *main_window;
  GtkWidget *clear_button;
  GtkWidget *scrolledwindow8;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GtkTreePath *path = NULL;
 


#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

  init_dive_data(&my_dive);
  main_window = create_main_window ();



  /* create tree model */
  model = create_model ();
  
  /* create tree view */
  compart_treeview = gtk_tree_view_new_with_model (model);
  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (compart_treeview), TRUE);
  g_object_unref (model);
  scrolledwindow8 = lookup_widget(GTK_WIDGET (main_window), "scrolledwindow8");
  gtk_container_add (GTK_CONTAINER (scrolledwindow8), compart_treeview);
  /* add columns to the tree view */
  add_columns (GTK_TREE_VIEW (compart_treeview));
  gtk_widget_show (compart_treeview);


  gtk_widget_show (main_window);
  clear_button = lookup_widget(GTK_WIDGET (main_window), "button_clear");
  gtk_signal_emit_by_name( GTK_OBJECT(clear_button), "clicked");

  gtk_main ();
  return 0;
}

